# encoding: UTF-8
from __future__ import division, absolute_import, print_function, unicode_literals

try:
    from tweet_markup.pipeline import construct_pipeline
except ImportError:
    # hack for testing system
    from .tweet_markup.pipeline import construct_pipeline

class SentimentAnalyzer(object):
    def __init__(self):
        self._pipeline = construct_pipeline() 
    
    def train(self, training_corpus):
        x_train = [tweet["text"] for tweet in training_corpus]
        y_train = [tweet["polarity"] for tweet in training_corpus]

        self._pipeline.fit(x_train, y_train)

    def getClasses(self, texts):
        return list(self._pipeline.predict(texts))
