#!/usr/bin/env python2
# encoding: UTF-8
from __future__ import division, absolute_import, print_function, unicode_literals

import os
import argparse
import itertools

import zipfile

def get_file_list(root):
    return itertools.chain(
        ["description.txt"],
        (
            os.path.join(dirpath, filename)
            for dirpath, dirnames, files in os.walk(root)
            for filename in files
            if os.path.splitext(filename)[1] == ".py"
        )
    )

def main():
    parser = argparse.ArgumentParser()
    parser.add_argument("destination", type=argparse.FileType("wb"))

    args = parser.parse_args()

    with args.destination:
        with zipfile.ZipFile(args.destination, "w") as egg:
            for filename in get_file_list("."):
                egg.write(filename)

if __name__ == "__main__":
   main()
