#encoding=UTF8
from sklearn.feature_extraction.text import CountVectorizer
from sklearn.naive_bayes import MultinomialNB

import re
url = re.compile('http[s]?://(?:[a-zA-Z]|[0-9]|[$-_@.&+]|[!*\(\),]|(?:%[0-9a-fA-F][0-9a-fA-F]))+')

class SentimentAnalyzer:
    classifier = None
    
    #constructor (optional)
    def __init__(self):
        self.classifier = MultinomialNB()
        self.vectorizer = CountVectorizer(ngram_range=(1, 1))
        
    #convert text to feature vector (optional)
    def featureExtractor(self, text):
        return self.vectorizer.transform(text)
        
    #trainer of classifier (optional)
    def train(self, training_corpus):
        #extract text-class pairs from corpus
        training_data = [(obj["text"], obj["polarity"]) for obj in training_corpus]
        corpus = map(lambda x: url.sub("",x[0]), training_data)
        y = map(lambda x: x[1], training_data)
        X = self.vectorizer.fit_transform(corpus)
        self.classifier.fit(X,y)
        
    #returns sentiment score of input text (mandatory)
    def getClasses(self, texts):
        feature_vector = self.featureExtractor(texts)
        return self.classifier.predict(feature_vector)

